/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mike Lee's code.
 *
 * The Initial Developer of the Original Code is
 * Mike Lee.
 * Portions created by the Initial Developer are Copyright (C) 2002
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *	Mike Lee <tseng_mike@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
//var mgPrefBI = mgPref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);

var isCallingBlog = false;		   // flag to indicate if calling if in progress

var returnUserInfo = false;
var returnUserBlogs = false;
var recentResult = null;
var blogInfoResult = null;
var recentPublish = false;

var xmlRpcClient;
var xmlRpc = getXmlRpc();
var serverurl;
var blogAppkey;
var blogid;
var username;
var password;


function initBlog()
{
	try {
		var defaultBlog = discussPref.getBoolPref("blogger.defaultBlog");
	} catch(ex) {
		defaultBlog = 0;
	}
	if (defaultBlog == true) {
		document.getElementById("blogDefault").value = discussPref.getCharPref("blogger.blogId");
	}
	serverurl = xmlRpc.createType(xmlRpc.STRING, {});
	blogAppkey = xmlRpc.createType(xmlRpc.STRING, {});
	blogid = xmlRpc.createType(xmlRpc.STRING, {});
	username = xmlRpc.createType(xmlRpc.STRING, {});
	password = xmlRpc.createType(xmlRpc.STRING, {});
	try {
		blogAppkey.data = discussPref.getCharPref("blogger.appkey");
		serverurl.data = discussPref.getCharPref("blogger.serverUrl");
//	  blogid.data = mgPref.getCharPref("blogId");
		blogid.data = document.getElementById("blogIDs").selectedItem.value;
		username.data = discussPref.getCharPref("blogger.username");
		password.data = discussPref.getCharPref("blogger.password");
	} catch (e) {
		dump ('Error');
		blogAppkey.data = "none";
		serverurl.data = "http://127.0.0.1/";
//	  blogid.data = mgPref.getCharPref("blogId");
		blogid.data = "";
		username.data = "noone";
		password.data = "none";
	}
}

function getClient() {
	 return Components.classes["@mozilla.org/xml-rpc/client;1"].createInstance(Components.interfaces.nsIXmlRpcClient);
}

function getXmlRpc() {
	 if (!xmlRpcClient) xmlRpcClient = getClient();
	 return xmlRpcClient;
}

/**
 * weblogUpdates.ping
 * return dictionary of success and message
 */
function weblogUpdatesPing(blogName, blogUrl)
{
	try {
		pingBlog = discussPref.getBoolPref("blogger.pingBlog");
	} catch (e) {
		pingBlog = false;
	}
	if (pingBlog == true) {
		var userlandServerurl = xmlRpc.createType(xmlRpc.STRING, {});
		userlandServerurl = "http://rpc.weblogs.com/RPC2";
		var siteName = xmlRpc.createType(xmlRpc.STRING, {});
		siteName.data = blogName;
		var siteUrl = xmlRpc.createType(xmlRpc.STRING, {});
		siteUrl.data = blogUrl;
		xmlRpc.init(userlandServerurl);
		xmlRpc.asyncCall(ULpingListener, null, "weblogUpdates.ping", [siteName, siteUrl], 2);
	}
}

var ULpingListener = {
	onResult: function(client, ctxt, result) {
		dictResult = result.QueryInterface(Components.interfaces.nsIDictionary);
		dictResult1 = dictResult.getValue("flerror");
		dictResult2 = dictResult.getValue("message");
		dictResult1 = dictResult1.QueryInterface(Components.interfaces.nsISupportsPRBool);
		dictResult2 = dictResult2.QueryInterface(Components.interfaces.nsISupportsString);
		statusReport("Weblog.com ping: " + dictResult2);
	}, onFault: function(client, ctxt, fault) {
		dump("Fault! " + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
		dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
	}
};

/**
 * getUserInfo return the blog user's information
 * returns a dictionary with userid, firstname, lastname, nickname, email, and url
 */
function getUserInfo()
{
	initBlog();
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(Listener, null, "blogger.getUserInfo", [blogAppkey, blogid, username, password], 4);
}

/**
 * getUserInfo return the user's blog(s) information
 * returns an array of dictionary with blogid, blogname, and url
 */
function getUserBlog()
{
	initBlog();
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(blogInfoListener, null, "blogger.getUsersBlogs", [blogAppkey, username, password], 3);
}

var blogInfoListener = {
	onResult: function(client, ctxt, result) {
		blogList = document.getElementById("blogIDs");
		blogInfoResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
		for (i = 0; i < blogInfoResult.Count(); i++) {
			dictResult = blogInfoResult.QueryElementAt(i, Components.interfaces.nsIDictionary);
			dictResult1 = dictResult.getValue("blogName");
			dictResult2 = dictResult.getValue("blogid");
			dictResult1 = dictResult1.QueryInterface(Components.interfaces.nsISupportsString);
			dictResult2 = dictResult2.QueryInterface(Components.interfaces.nsISupportsString);
			blogList.insertItemAt(i + 1, dictResult1.data, dictResult2.data);
		}
		statusReport("Index loaded");
		//getRecentPosts(retrievePost);
	}, onFault: function(client, ctxt, fault) {
		dump("Fault! " + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
		dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
	}
};

/**
 * newPost post a new entry to blogger
 * returns the unique postId assigned
 */
function newPost(postContent, postPublish)
{
	initBlog();
	var content = xmlRpc.createType(xmlRpc.STRING, {});
	content.data = postContent;
	var publish = xmlRpc.createType(xmlRpc.BOOLEAN, {});
	publish.data = postPublish;
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(newPostListener, null, "blogger.newPost",
					 [blogAppkey, blogid, username, password, content, publish], 6);
}

var newPostListener = {
	onResult: function(client, ctxt, result) {
		result = result.QueryInterface(Components.interfaces.nsISupportsPrimitive);
		if (result.type == 2)
			var blogStatus = result.QueryInterface(Components.interfaces.nsISupportsString);
		else
			document.getElementById("statusbar-display").label = "Error! Blog server return: " + result.type;
		blogStatus = blogStatus.data;
		statusReport("Blog server: " + blogStatus);
		statusReport("Reloading index");
		getRecentPosts(retrievePost);
		deleteTmpFile();
		saveInterval = window.setInterval("saveTmpFile()", interval * 1000); //start autosave
	}, onFault: function(client, ctxt, fault) {
		dump("Fault! " + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
		dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
	}
};


/**
 * editPost edit an existing post
 * return boolean
 */
function editPost(postID, postContent, postPublish)
{
	initBlog();
	var postId = xmlRpc.createType(xmlRpc.STRING, {});
	postId.data = postID;
	var content = xmlRpc.createType(xmlRpc.STRING, {});
	content.data = postContent;
	var publish = xmlRpc.createType(xmlRpc.BOOLEAN, {});
	publish.data = postPublish;
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(editPostListener, null, "blogger.editPost",
					 [blogAppkey, postId, username, password, content, publish], 6);
}

var editPostListener = {
	onResult: function(client, ctxt, result) {
		result = result.QueryInterface(Components.interfaces.nsISupportsPrimitive);
		if (result.type == 4)
			var blogStatus = result.QueryInterface(Components.interfaces.nsISupportsPRBool);
		else
			document.getElementById("statusbar-display").label = "Error! Blog server return: " + result.type;
		blogStatus = blogStatus.data;
		statusReport("Blog server: " + blogStatus);
		getRecentPosts(retrievePost);
		statusReport("Reloading index");
		deleteTmpFile();
		saveInterval = window.setInterval("saveTmpFile()", interval * 1000); //start autosave
	}, onFault: function(client, ctxt, fault) {
		dump("Fault! " + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
		dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
	}
};


/**
 * getPost get an post's informatiom
 * return a dictionary of userid, postid, content, and dateCreated
 */
function getPost(postID)
{
	initBlog();
	var postId = xmlRpc.createType(xmlRpc.STRING, {});
	postId.data = postID;
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(Listener, null, "blogger.getPost", [blogAppkey, postId, username, password], 4);
}

/**
 * deletePost delete an existing post
 * return boolean
 */
function deletePost(postID)
{
	initBlog();
	var postId = xmlRpc.createType(xmlRpc.STRING, {});
	postId.data = postID;
	var publish = xmlRpc.createType(xmlRpc.BOOLEAN, {});
	publish.data = false;
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(deletePostListener, null, "blogger.deletePost",
					[blogAppkey, postId, username, password, publish], 5);
}

var deletePostListener = {
	onResult: function(client, ctxt, result) {
		result = result.QueryInterface(Components.interfaces.nsISupportsPrimitive);
		if (result.type == 4)
			var blogStatus = result.QueryInterface(Components.interfaces.nsISupportsPRBool);
		else
			document.getElementById("statusbar-display").label = "Error! Blog server return: " + result.type;
		blogStatus = blogStatus.data;
		statusReport("Blog server: " + blogStatus);
		getRecentPosts(retrievePost);
		statusReport("Reloading index");
	}, onFault: function(client, ctxt, fault) {
		dump("Fault! " + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
		dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
	}
};

/**
 * getRecentPost get an array of recent post (<20)
 * return an array of dictionary with postid, content, userid, dateCreated
 */
function getRecentPosts(numPost)
{
	initBlog();
	if (recentResult) { 	// clear the existing recent post first to avoid duplicate
		temp2 = document.getElementById("postIDs");
		for (index = 0; index < recentResult.Count(); index++) {
			temp2.removeItemAt(1);
		}
		recentResult = null;
	}
	if (recentLocalResult) {
		for (index = 0; index < recentLocalResult; index++) {
			recentList.removeItemAt(1);
		}
		recentLocalResult = 0;
	}

	var prevBlogPanel = document.getElementById('prevBlogPostList');
	listCount = prevBlogPanel.getRowCount();
	for (scraptCount = 0; scraptCount < listCount; scraptCount++) {
		prevBlogPanel.removeItemAt(0);
	}

	var postNum = xmlRpc.createType(xmlRpc.INT, {});
	postNum.data = numPost;
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(recentPostListener, null, "blogger.getRecentPosts",
					 [blogAppkey, blogid, username, password, postNum], 5);
}


var recentPostListener = {
	onResult: function(client, ctxt, result) {
		blogList = document.getElementById("postIDs");
		newBlogList = document.getElementById("prevBlogPostList");
		recentResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
		for (i = 0; i < recentResult.Count(); i++) {
			dictResult = recentResult.QueryElementAt(i, Components.interfaces.nsIDictionary);
			dictResult1 = dictResult.getValue("dateCreated");
			dictResult2 = dictResult.getValue("postid");
			dictResult1 = dictResult1.QueryInterface(Components.interfaces.nsISupportsPRTime);
			var time = new Date(dictResult1.data);
			dictResult2 = dictResult2.QueryInterface(Components.interfaces.nsISupportsString);
			blogList.insertItemAt(i + 1, time.toGMTString(), dictResult2.data);

			blogContent = dictResult.getValue("content").QueryInterface(Components.interfaces.nsISupportsString);

			var treeItem = document.createElement("listitem" );
			treeItem.setAttribute("label", time.toGMTString());
			treeItem.setAttribute("value", dictResult2.data);
			treeItem.setAttribute("onclick", "saveTmpFile();getContent(this.value);");
//			  treeItem.setAttribute("tooltiptext", blogContent);

/*			  var treeCell = document.createElement("listcell");
			treeCell.setAttribute("flex" , "1");
			treeCell.setAttribute("crop", "right");

			var treeCellVBox = document.createElement("vbox");
			treeCellVBox.setAttribute("crop", "right");
			treeCellVBox.setAttribute("flex", "1");


			var text1 = document.createElement("label");
			text1.setAttribute("crop", "right");
			text1.setAttribute("value" , time.toGMTString());

			var text2 = document.createElement("label");
			text2.setAttribute("crop", "right");
			text2.setAttribute("value" , blogContent);

			treeCellVBox.appendChild(text1);
//			  treeCellVBox.appendChild(text2);
			treeCell.appendChild(treeCellVBox);
			treeItem.appendChild(treeCell);*/

			newBlogList.appendChild(treeItem);
		}
		statusReport("Index loaded");
		if (recentPublish) {
			pingSelectedBlog();
			recentPublish = false;
		}
	}, onFault: function(client, ctxt, fault) {
		dump("Fault! " + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
		dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
	}
};

