include('chrome://jslib/content/io/io.js');

var discussPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
discussPref = discussPref.getBranch(null);

var du = new DirUtils();
var userDir = du.getMozUserHomeDir();
var chromeDir = du.getChromeDir();
var fu = new FileUtils();
var fullPath = fu.append(userDir, "discussTmp.html");

// dump ("\nUser dir: " + userDir);
// dump ("\nfullPath: " + fullPath);

var editorShell;	 // editorShell instance
var newPostIndex;

var saveInterval;	 // save internal
var isEditorLoaded = false; // editor loaded flag
var firstLoad = false;
var interval

try {
  interval = discussPref.getIntPref("discuss.editorDump");
} catch (e) {
  interval = 10;
}

var discussFormatbarOpen = false;

function hideDoc()
{
	var doc = document.getElementById('bottomBar');
	var splitter = document.getElementById('discussSplit');
	if (doc.collapsed == false || splitter.collapsed == false) {
		doc.collapsed = true;
		splitter.collapsed = true;
		window._content.focus();
		saveTmpFile();						// save tmp file
		window.clearInterval(saveInterval); // stop auto save
	 } else {								// open discuss
		doc.collapsed = false;
		splitter.collapsed = false;
		if (!isEditorLoaded) {				  // init editor instance if not already done so
			textBoxInit();
			editorOnLoad();
			isEditorLoaded = true;
			try {
			  defaultView = discussPref.getBoolPref("discuss.defaultSourceView");
			} catch (e) {
			  defaultView = false;
			}
			if (defaultView) { //if default as source view
				document.getElementById("discussEditorType").setAttribute("selectedIndex","1");
				document.getElementById("editorSwitch").setAttribute("label", "normal");
				document.getElementById("discuss-open-formatbar").setAttribute("disabled", true);
				editorShell.SetDisplayMode(3);
				var fh = new File(fullPath);
				if (fh.exists()) {
					fh.open();
					var docContent = fh.read();
					fh.close();
				}
				editorOpen(cleanSource(docContent));
				firstLoad = true;
			}
			newPostIndex = document.getElementById("postIDs").selectedItem;
			getUserBlog();
		}
		saveInterval = window.setInterval("saveTmpFile()", interval * 1000); //start autosave
	}
}

function editorOnLoad()
{
//	  alert (window.frames.length);
	var url;
	editorShell = document.getElementById("edit-frame").editorShell;
	editorShell.editorType = 'html';
	for (wCount = 0; wCount < window.length; wCount++) {
	  if (window.frames[wCount].name == "edit-frame") {
		editorShell.webShellWindow = window.frames[wCount]; //get the window instance bottombar is in
		editorShell.contentWindow = window.frames[wCount];
	  }
	}
	editorShell.RegisterDocumentStateListener(DocumentStateListener);
	editorShell.contentsMIMEType = "text/html";
//	  editorShell.SetDocumentCharacterSet("");
	dump ("\nOpening file: " + fullPath);
	var fh = new File(fullPath);
	if (fh.exists()) {
		url = fullPath;
	} else {
		fh.open('w');
		fh.write("<html><head></head><body></body></html>");
		fh.close();
	}
	editorShell.LoadUrl(url);
//	  editorShell.LoadUrl("about:blank");
	if (editorShell) {
		editorShell = editorShell.QueryInterface(Components.interfaces.nsIEditorShell);
	}
//	  collapseToolbar(discussBar2);
	loadChannels();
}

function textBoxInit()
{
	sourceEditor = document.getElementById("scraptDocument");
	try {
		var sourceWordwrap = discussPref.getBoolPref("discuss.sourceWordwrap");
	} catch (ex) {
		var sourceWordwrap = false;
	}
	if (sourceWordwrap) {
		sourceEditor.setAttribute("cols","1");
	} else {
		sourceEditor.removeAttribute("cols");
	}
}

var DocumentStateListener =
{
  NotifyDocumentCreated: function()
  {
	addEditorListener();
	editorHandle = editorShell.editor.QueryInterface(Components.interfaces.nsIEditor);
	selectionHandle = editorHandle.selection.QueryInterface(Components.interfaces.nsISelection);
	selectionHd2 = selectionHandle.QueryInterface(Components.interfaces.nsISelectionPrivate);
	selectionHd2.addSelectionListener(selectListener);
  },
  NotifyDocumentWillBeDestroyed: function() {},
  NotifyDocumentStateChanged:function( isNowDirty )
  {
  }
};

function addEditorListener()
{
	var editor = editorShell.editor.QueryInterface(Components.interfaces.nsIEditor);
	editor.addEditActionListener(DocumentActionListener);
}

var selectListener =
{
	notifySelectionChanged: function(doc, selection, reason) {},
};

function testSelection()
{
  currentSelectionText = currentSelectionText.QueryInterface(Components.interfaces.nsISelection);
  alert(currentSelectionText.toString());
}

var DocumentActionListener =
{
	WillCreateNode: function(tag, parent, position) {},
	DidCreateNode: function(tag, node, parent, position, result) {},
	WillInsertNode: function(node, parent, position) {},
	DidInsertNode: function(node, parent, position, result) {},
	WillDeleteNode: function(child) {},
	DidDeleteNode: function(child, result) {},
	WillSplitNode: function(existingRightNode, offset) {},
	DidSplitNode: function(existingRightNode, offset, newLeftNode, result) {},
	WillJoinNodes: function(leftNode, rightNode, parent) {},
	DidJoinNodes: function(leftNode, rightNode, parent, result) {},
	WillInsertText: function(textNode, offset, string) {
/*		  alert ("insert: " + string);
//		  parentNode = textNode.QueryInterface(Components.interfaces.nsIDOMNode).parentNode;
		parentNode = newlinkNode;
		if (parentNode.nodeName == "A") {
			 alert('god');

//			  textNode = textNode.QueryInterface(Components.interfaces.nsIDOMNode);
			parentNode.replaceChild(textNode, parentNode.firstChild);
//			  editorHandle = editorShell.editor.QueryInterface(Components.interfaces.nsIEditor);
//			  editorHandle.createNode(parentNode, parentNode, 0);
		}
		newlinkNode = null;*/
	},
	DidInsertText: function(textNode, offset, string, result) {},
	WillDeleteText: function(textNode, offset, length) {},
	DidDeleteText: function(textNode, offset, length, result) {},
	WillDeleteSelection: function(selection) {
/*		  alert("delete: " + selection.QueryInterface(Components.interfaces.nsISelection).toString());
		aElement = editorShell.GetSelectedElement("a");
		editorHandle = editorShell.editor.QueryInterface(Components.interfaces.nsIEditor);
		selectionHandle = editorHandle.selection.QueryInterface(Components.interfaces.nsISelection);
		if (selectionHandle.containsNode(aElement, true)) {
			alert ('contain');
			newlinkNode = editorShell.editor.QueryInterface(Components.interfaces.nsIHTMLEditor).getSelectedElement("A");
		}*/
	},
	DidDeleteSelection: function(selection) {
	},
};


//*******************************************
// new experimental codes
//*******************************************

function getForms()
{
	var formParameterCount = 0;
	var formParameter = new Array();
	var methodCall = "";
	var formList = window.frames[1].document.forms;
	var formField = formList[0].elements;
	var length = formField.length;
		if (length > 0) {
		for (i = 0; i < length; i++) {
			formElement = formField[i].type.toLowerCase();
			if (formElement == "submit") {
				alert ("method: " + formField[i].value);
				formParameter[formParameterCount] = formField[i].value;
			} else if (formElement == "text") {
				alert ("parameter: " + formField[i].value);
			} else if (formElement == "hidden") {
				methodCall = methodCall + formField[i].name + "=" + formField[i].value;
			} else {
				alert (formField[i].type);
			}
		}
		alert (formList[0].action + "?" + methodCall);
	}
}

function testComponent()
{
	var fh = new File("c:\classes.txt");
	fh.open('w');
	var countXp = 0;
	var badXpcom = Components.classes["@mozilla.org/registry;1"].getService(Components.interfaces.nsIRegistry);
	var allXpcom = Components.classes;
	for (comonentsXp in allXpcom) {
		countXp++;
		var clazz = Components.classes[comonentsXp];
		var obj  = clazz.createInstance();
		var srv = obj.QueryInterface(Components.interfaces.nsIClassInfo);
		fh.write(comonentsXp + " " + srv.classDescription + "\n");
	}
	alert (countXp);
	fh.close();
//	  alert (badXpcom.currentUserName);
}



